int ENG1_N1=9;
int ENG2_N1=3;
int APU_N1=6;

int BAT_SW=A0;
int APU_Master_SW=A1;
int APU_Start_SW=A2;
int APU_Bleed_SW=A3;
int ENG1_Start=A4;
int ENG2_Start=A5;

int APU_Bleed = 12;
int APU_Avail = 13;

int APU_State = 0;
int ENG1_State = 0;
int ENG2_State = 0;

int APU_Bleed_State = 0;
int Engine1_Speed = 0;
int Engine2_Speed = 0;

int Schaltwert = 500;

int APU_Speed = 0;


void setup(){
  pinMode(ENG1_N1,OUTPUT);
  pinMode(ENG2_N1,OUTPUT);
  pinMode(APU_N1,OUTPUT);

  pinMode(APU_Bleed, OUTPUT);
  pinMode(APU_Avail, OUTPUT);

  digitalWrite(APU_Bleed, HIGH);
  digitalWrite(APU_Avail, HIGH);

  delay(5000);

  digitalWrite(APU_Bleed, LOW);
  digitalWrite(APU_Avail, LOW);

  while (Engine1_Speed < 255){
    analogWrite(ENG1_N1,Engine1_Speed);
    analogWrite(ENG2_N1,Engine1_Speed);
    analogWrite(APU_N1,Engine1_Speed);
    Engine1_Speed ++;
    delay(10);
  }

  delay(6000);

  Engine1_Speed = 0;
  analogWrite(ENG1_N1,Engine1_Speed);
  analogWrite(ENG2_N1,Engine1_Speed);
  analogWrite(APU_N1,Engine1_Speed);  
}
 
void loop(){
  if (analogRead(BAT_SW) > Schaltwert || ENG1_State == 1 || ENG2_State == 1){
    if (APU_State == 0 && analogRead(APU_Master_SW) > Schaltwert && analogRead(APU_Start_SW) > Schaltwert){
      APU_State = 1;      
    }
    if (APU_State == 1 && analogRead(APU_Master_SW) > Schaltwert && APU_Speed < 255){
      analogWrite(APU_N1,APU_Speed);
      delay(20);
      APU_Speed ++;
    }
  }
  if (analogRead(APU_Master_SW) < Schaltwert || APU_State == 0){
    if (APU_Speed > 0){
      analogWrite(APU_N1,APU_Speed);
      delay(10);
      APU_Speed = APU_Speed - 1;
      APU_State = 0; 
    }
  }
  if (APU_Speed == 255){
    digitalWrite(APU_Avail, HIGH);
  }else{
    digitalWrite(APU_Avail, LOW);
  }

  if (APU_State == 1 ||analogRead(BAT_SW) > Schaltwert || ENG1_State == 1 || ENG2_State == 1){
    if (analogRead(APU_Bleed_SW) > Schaltwert){ 
      APU_Bleed_State = 1;
      digitalWrite(APU_Bleed, HIGH);
    }else{
      APU_Bleed_State = 0;
      digitalWrite(APU_Bleed, LOW);
      }  
  }else{
    APU_Bleed_State = 0;
    digitalWrite(APU_Bleed, LOW);
  }

  if (analogRead(ENG1_Start) > Schaltwert && APU_Speed == 255 && APU_Bleed_State == 1){
    ENG1_State = 1;
    if (Engine1_Speed < 85){
      analogWrite(ENG1_N1,Engine1_Speed);
      delay(20);
      Engine1_Speed ++; 
    }
  }
  
  if (analogRead(ENG1_Start) < Schaltwert && ENG1_State == 1){
    ENG1_State = 0;
  }

  if (ENG1_State == 0 && Engine1_Speed > 0){
      analogWrite(ENG1_N1,Engine1_Speed);
      delay(10);
      Engine1_Speed = Engine1_Speed - 1;  
  }

  if (ENG1_State == 1 && Engine1_Speed < 85 && Engine1_Speed > 0 && APU_Bleed_State == 0){
      analogWrite(ENG1_N1,Engine1_Speed);
      delay(10);
      Engine1_Speed = Engine1_Speed - 1;   
  }

  if (analogRead(ENG2_Start) > Schaltwert && APU_Speed == 255 && APU_Bleed_State == 1){
    ENG2_State = 1;
    if (Engine2_Speed < 85){
      analogWrite(ENG2_N1,Engine2_Speed);
      delay(20);
      Engine2_Speed ++; 
    }
  }
  
  if (analogRead(ENG2_Start) < Schaltwert && ENG2_State == 1){
    ENG2_State = 0;
  }

  if (ENG2_State == 0 && Engine2_Speed > 0){
      analogWrite(ENG2_N1,Engine2_Speed);
      delay(10);
      Engine2_Speed = Engine2_Speed - 1;  
  }

  if (ENG2_State == 1 && Engine2_Speed < 85 && Engine2_Speed > 0 && APU_Bleed_State == 0){
      analogWrite(ENG2_N1,Engine2_Speed);
      delay(10);
      Engine2_Speed = Engine2_Speed - 1;    
  }
    
  
}
